// BarChartView.cpp : implementation of the CBarChartView class
//

#include "stdafx.h"
#include "BarChart.h"
#include "BarChartDoc.h"
#include "BarChartView.h"
#include "BarDataDialog.h"     // add for resource information

CBarDataDialog dlg;

#define maxnumber 12

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBarChartView

IMPLEMENT_DYNCREATE(CBarChartView, CView)

BEGIN_MESSAGE_MAP(CBarChartView, CView)
	//{{AFX_MSG_MAP(CBarChartView)
	ON_WM_SIZE()
	ON_COMMAND(IDM_INPUT, OnInput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBarChartView construction/destruction

CBarChartView::CBarChartView()
{
}

CBarChartView::~CBarChartView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CBarChartView diagnostics

#ifdef _DEBUG
void CBarChartView::AssertValid() const
{
	CView::AssertValid();
}

void CBarChartView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBarChartDoc* CBarChartView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBarChartDoc)));
	return (CBarChartDoc*)m_pDocument;
}
#endif //_DEBUG

void CBarChartView::OnDraw(CDC* pDC) 
{
	CBarChartDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    static DWORD dwColor[12] = {RGB(0, 0, 0),        //black
                                RGB(255, 0, 0),      //red
                                RGB(0, 255, 0),      //green
                                RGB(0, 0, 255),      //blue
                                RGB(255, 255, 0),    //yellow
                                RGB(255, 0, 255),    //magenta
                                RGB(0, 255, 255),    //cyan
                                RGB(125, 125, 0),    //blend 1
                                RGB(125, 0, 125),    //blend 2
                                RGB(0, 125, 125),    //blend 3
                                RGB(125, 125, 125),  //blend 4  
                                RGB(255, 255, 255)}; //white
  
    CFont newfont;
    CFont* oldfont;
    CBrush newbrush;
    CBrush* oldbrush;
    
	int i,iNBars,iBarWidth,iBarMax;
    int ilenMaxLabel;
    int x1, x2, y1, y2, z1, z2;
    static char LValues[80];
    static char HValues[80]; 
    int iBarSize[maxnumber];
    int iBarSizeScaled[maxnumber];
    char sbuffer[10], *strptr;	
    char szBarLabel[12][20];
    static char *n, *p; 

    // make copies of data for re-drawing
    strcpy(HValues, pDoc -> GHValues);
    strcpy(LValues, pDoc -> GLValues);

    // parse string to get bar heights
    iNBars = 0;
    i = 0;
    n = HValues;
    p = strtok(n, ",");
    while ((n != NULL)) {
        iBarSize[i] = atoi(n);
	    p = strtok(NULL, ",");
	    n = p;
        iNBars++;
	    i++;
	}

    // parse string to get bar labels
    i = 0;
    n = LValues;
    p = strtok(n, ",");
    while ((n != NULL)) {
        strcpy(szBarLabel[i], n);
	    p = strtok(NULL, ",");
	    n = p;
	    i++;
	}

    iBarWidth = 400 / iNBars;

    // Find bar with maximum height and scale
    iBarMax = iBarSize[0];
    for(i = 0; i < iNBars; i++)
        if (iBarMax < iBarSize[i]) iBarMax = iBarSize[i];

    // Convert maximum y value to a string
    strptr = _itoa(iBarMax, sbuffer, 10);
    ilenMaxLabel = strlen(sbuffer);
 
    // Scale bars in array.  Highest bar = 270
    for (i = 0; i < iNBars; i++)
        iBarSizeScaled[i] = iBarSize[i] * (270 / iBarMax);

    // Create custom viewport and map mode
    pDC -> SetMapMode(MM_ISOTROPIC);
    pDC -> SetWindowExt(640, 480);
    pDC -> SetViewportExt(m_cxClient, m_cyClient);
    pDC -> SetViewportOrg(0, 0);

    // Draw text if window is large enough
    if ((m_cxClient > 300) && (m_cyClient > 200)) {
        newfont.CreateFont(20, 12, 900, 900, FW_NORMAL,
                           FALSE, FALSE, FALSE,
                           OEM_CHARSET, OUT_DEFAULT_PRECIS,
                           CLIP_DEFAULT_PRECIS,
                           DEFAULT_QUALITY,
                           34,
                           "Arial");
      oldfont = pDC -> SelectObject(&newfont);
      pDC -> TextOut(50, 200 + (strlen(pDoc -> YString) * 10 / 2),
                     pDoc -> YString, strlen(pDoc -> YString));
	  pDC -> SelectObject(oldfont);
      newfont.DeleteObject();

      newfont.CreateFont(20, 12, 0, 0, FW_NORMAL, 
                         FALSE, FALSE, FALSE, OEM_CHARSET,
                         OUT_DEFAULT_PRECIS,
                         CLIP_DEFAULT_PRECIS,
                         DEFAULT_QUALITY,
                         34, 
                         "Arial");
      oldfont = pDC -> SelectObject(&newfont);
      pDC -> TextOut((300 - (strlen(pDoc -> TString) * 10 / 2)),
                      15, pDoc -> TString, strlen(pDoc -> TString));
      pDC -> TextOut((300 - (strlen(pDoc -> XString) * 10 / 2)),
                      365, pDoc -> XString,strlen(pDoc -> XString));
      pDC -> TextOut((90 - ilenMaxLabel * 12), 70, strptr, ilenMaxLabel);
	  pDC -> SelectObject(oldfont);
      newfont.DeleteObject();
	}
 
    // Draw coordinate axis
    pDC -> MoveTo(99, 49);
    pDC -> LineTo(99, 350);
    pDC -> LineTo(500, 350);
    pDC -> MoveTo(99, 350);
 
    // Initial values
    x1 = 100;
    y1 = 350;
    z1 = 50;
    z2 = z1 + 15;
    x2 = x1 + iBarWidth;

    // Draw each bar
    for(i = 0; i < iNBars; i++) {

      newbrush.CreateSolidBrush(dwColor[i]);
      oldbrush = pDC -> SelectObject(&newbrush);
      y2 = 350 - iBarSizeScaled[i];
      pDC -> Rectangle(x1, y1, x2, y2);
      x1 = x2;
      x2 += iBarWidth;

      // Draw labels
      if ((strlen(szBarLabel[0]) != 0) && (m_cxClient > 300) &&
          (m_cyClient > 200)) {
          pDC -> Rectangle(545, z1, 560, z2);
          pDC -> TextOut(565, z1, szBarLabel[i],
                         strlen(szBarLabel[i]));
          z1 = z2 + 15;
          z2 += 30;
	  } 
    pDC -> SelectObject(&newbrush);
    newbrush.DeleteObject(); 
	}	
}

/////////////////////////////////////////////////////////////////////////////
// CBarChartView message handlers

void CBarChartView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
    m_cxClient = cx;
    m_cyClient = cy;
}

void CBarChartView::OnInput() 
{
    CBarDataDialog dlg (this);
    int result = dlg.DoModal();

    if(result == IDOK) {
        CBarChartDoc* pDoc = GetDocument();
        ASSERT_VALID(pDoc);

        pDoc -> TString = dlg.m_TString;
        pDoc -> XString = dlg.m_XString;
        pDoc -> YString = dlg.m_YString;
        pDoc -> GHValues = dlg.m_GHValues;
        pDoc -> GLValues = dlg.m_GLValues;

        InvalidateRect(NULL, TRUE);
    }
}

