// FourierView.cpp : implementation of the CFourierView class
//

#include "stdafx.h"
#include "Fourier.h"

#include "FourierDoc.h"
#include "FourierView.h"

#include "FourierDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFourierView

IMPLEMENT_DYNCREATE(CFourierView, CView)

BEGIN_MESSAGE_MAP(CFourierView, CView)
    ON_WM_SIZE()
    ON_COMMAND(IDD_FILE_DATAENTRY, OnFourier)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFourierView construction/destruction

CFourierView::CFourierView()
{
	// TODO: add construction code here

}

CFourierView::~CFourierView()
{
}

BOOL CFourierView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFourierView drawing

void CFourierView::OnDraw(CDC* pDC)
{
	CFourierDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    // all remaining code for Fourier Series
    int ang;
    double y, yp;

    pDC->SetMapMode(MM_ISOTROPIC);
    pDC->SetWindowExt(500, 500);
    pDC->SetViewportExt(m_cxClient, -m_cyClient);
    pDC->SetViewportOrg(m_cxClient / 20, m_cyClient / 2);

    ang = 0;
    yp = 0;

    // draw x & y coordinate axes
    pDC -> MoveTo(0, 240);
    pDC -> LineTo(0, -240);
    pDC -> MoveTo(0, 0);
    pDC -> LineTo(400, 0);
    pDC -> MoveTo(0, 0);

    // draw a label
    pDC->TextOut(420, 10, pDoc -> mytext);

    // draw actual Fourier waveform
    for (int i = 0; i <= 400; i++) {
        for (int j = 1; j <= pDoc -> myterms; j++) {

            y = (250.0 / ((2.0 * j) - 1.0)) *  \
                sin(((j * 2.0 ) - 1.0) * \
                (ang * 2.0 * 3.14159265359 / 400.0)); 
            yp += y;
        }
        pDC -> LineTo(i, (int)yp);
        yp -= yp;
        ang++;
    }
}

/////////////////////////////////////////////////////////////////////////////
// CFourierView diagnostics

#ifdef _DEBUG
void CFourierView::AssertValid() const
{
	CView::AssertValid();
}

void CFourierView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFourierDoc* CFourierView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFourierDoc)));
	return (CFourierDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFourierView message handlers

void CFourierView::OnSize(UINT nType, int cx, int cy)
{
    CView::OnSize(nType, cx, cy);
   
    m_cxClient = cx;
    m_cyClient = cy;
}

void CFourierView::OnFourier(void)
{
    CFourierDlg dlg (this);
    int result = dlg.DoModal();
    
    if(result == IDOK) {
        CFourierDoc* pDoc = GetDocument();
        ASSERT_VALID(pDoc);
        pDoc -> myterms = dlg.m_terms;
        pDoc -> mytext  = dlg.m_text;
        Invalidate();
    }
}
