// gdiView.cpp : implementation of the CgdiView class
//

#include "stdafx.h"
#include "gdi.h"

#include "gdiDoc.h"
#include "gdiView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CgdiView

IMPLEMENT_DYNCREATE(CgdiView, CView)

BEGIN_MESSAGE_MAP(CgdiView, CView)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CgdiView construction/destruction

CgdiView::CgdiView()
{
	// TODO: add construction code here

}

CgdiView::~CgdiView()
{
}

BOOL CgdiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CgdiView drawing

void CgdiView::OnDraw(CDC* pDC)
{
	CgdiDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    static DWORD dwColor[9]={RGB(0,0,0),        //black
                             RGB(255,0,0),      //red
                             RGB(0,255,0),      //green
                             RGB(0,0,255),      //blue
                             RGB(255,255,0),    //yellow
                             RGB(255,0,255),    //magenta
                             RGB(0,255,255),    //cyan
                             RGB(127,127,127),  //gray
                             RGB(255,255,255)}; //white
    int xcoord;
    POINT polylpts[4],polygpts[5];

    CBrush newbrush;
    CBrush* oldbrush;
    CPen  newpen;
    CPen* oldpen;

    // draws a wide black diagonal line
    newpen.CreatePen(PS_SOLID,6,dwColor[0]);
    oldpen=pDC->SelectObject(&newpen);
    pDC->MoveTo(0,0);
    pDC->LineTo(640,430);
    pDC->TextOut(70,20,"<-diagonal line",15);
    // delete pen objects
    pDC->SelectObject(oldpen);
    newpen.DeleteObject();

    // draws a blue arc
    newpen.CreatePen(PS_DASH,1,dwColor[3]);
    oldpen=pDC->SelectObject(&newpen);
    pDC->Arc(100,100,200,200,150,175,175,150);
    pDC->TextOut(80,180,"small arc->",11);
    // delete pen objects
    pDC->SelectObject(oldpen);
    newpen.DeleteObject();

  // draws a wide green chord
  newpen.CreatePen(PS_SOLID,8,dwColor[2]);
  oldpen=pDC->SelectObject(&newpen);
  pDC->Chord(550,20,630,80,555,25,625,70);
  pDC->TextOut(485,30,"chord->",7);
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

  // draws and fills a red ellipse
  newpen.CreatePen(PS_SOLID,1,dwColor[1]);
  oldpen=pDC->SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[1]);
  oldbrush=pDC->SelectObject(&newbrush);
  pDC->Ellipse(180,180,285,260);
  pDC->TextOut(210,215,"ellipse",7);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

  // draws and fills a blue circle with ellipse function
  newpen.CreatePen(PS_SOLID,1,dwColor[3]);
  oldpen=pDC->SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[3]);
  oldbrush=pDC->SelectObject(&newbrush);
  pDC->Ellipse(380,180,570,370);
  pDC->TextOut(450,265,"circle",6);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

  // draws a black pie wedge and fills with green
  newpen.CreatePen(PS_SOLID,1,dwColor[0]);
  oldpen=pDC->SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[2]);
  oldbrush=pDC->SelectObject(&newbrush);
  pDC->Pie(300,50,400,150,300,50,300,100);
  pDC->TextOut(350,80,"<-pie wedge",11);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

  // draws a black rectangle and fills with gray
  newbrush.CreateSolidBrush(dwColor[7]);
  oldbrush=pDC->SelectObject(&newbrush);
  pDC->Rectangle(50,300,150,400);
  pDC->TextOut(160,350,"<-rectangle",11);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
    
  // draws a black rounded rectangle and fills with blue
  newbrush.CreateHatchBrush(HS_CROSS,dwColor[3]);
  oldbrush=pDC->SelectObject(&newbrush);
  pDC->RoundRect(60,310,110,350,20,20);
  pDC->TextOut (120,310,"<------rounded rectangle",24);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
  
  // draws several green pixels
  for(xcoord=400;xcoord<450;xcoord+=3)
    pDC->SetPixel(xcoord,150,0L);
  pDC->TextOut(455,145,"<-pixels",8);

  // draws several wide magenta lines with polyline
  newpen.CreatePen(PS_SOLID,3,dwColor[5]);
  oldpen=pDC->SelectObject(&newpen);
  polylpts[0].x=10;
  polylpts[0].y=30;
  polylpts[1].x=10;
  polylpts[1].y=100;
  polylpts[2].x=50;
  polylpts[2].y=100;
  polylpts[3].x=10;
  polylpts[3].y=30;
  pDC->Polyline(polylpts,4);
  pDC->TextOut(10,110,"polyline",8);
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

  // draws a wide cyan polygon and
  // fills with diagonal yellow
  newpen.CreatePen(PS_SOLID,4,dwColor[6]);
  oldpen=pDC->SelectObject(&newpen);
  newbrush.CreateHatchBrush(HS_FDIAGONAL,dwColor[4]);
  oldbrush=pDC->SelectObject(&newbrush);
  polygpts[0].x=40;
  polygpts[0].y=200;
  polygpts[1].x=100;
  polygpts[1].y=270;
  polygpts[2].x=80;
  polygpts[2].y=290;
  polygpts[3].x=20;
  polygpts[3].y=220;
  polygpts[4].x=40;
  polygpts[4].y=200;
  pDC->Polygon(polygpts,5);
  pDC->TextOut(70,210,"<-polygon",9);
  // delete brush objects
  pDC->SelectObject(oldbrush);
  newbrush.DeleteObject();
  // delete pen objects
  pDC->SelectObject(oldpen);
  newpen.DeleteObject();

}

/////////////////////////////////////////////////////////////////////////////
// CgdiView diagnostics

#ifdef _DEBUG
void CgdiView::AssertValid() const
{
	CView::AssertValid();
}

void CgdiView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CgdiDoc* CgdiView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CgdiDoc)));
	return (CgdiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CgdiView message handlers
